Subject: Re: bug#31688: 26.1.50; Byte compiler confuses two string variables

From: Eli Zaretskii <[email-masked]>
Date: Mon, 04 Jun 2018 18:58:19 +0300

> Date: Mon, 04 Jun 2018 22:02:27 +1200
> From: Phil Sainty <[email-masked]>
> Cc: Gemini Lasswell <[email-masked]>, Noam Postavsky <[email-masked]>,
> 	bug-gnu-emacs <bug-gnu-emacs-bounces+psainty=[email-masked]>,
> 	[email-masked]
> 
> Again, it bothers me to think that someone could observe a bug when
> running byte-compiled code, and try to debug it but, through the
> process of instrumenting functions for debugging, unwittingly change
> the behaviour of the code such that the bug no longer occurs.

Byte compilation includes optimizations, and the fact that optimized
code can behave differently from unoptimized one is well known in
every programming language.  When you get differences, you have code
that relies on undefined behavior, which I believe is the point
Andreas was making.